#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "cwlook.h"

CWWINDOW *cwcurntwnd;

void cwactivate(CWWINDOW *cw,int fill)
{
	if (cw && cw->win) {
		_curntwnd=cw->win;
		_drawbox(cw->win->x1,cw->win->y1,
			cw->win->x2,cw->win->y2,DOUBLEFRAME,cw->col.factive,fill);
		if (cw->title) {
			_vputc(cw->win->x1,cw->win->y1+2,(cw->col.factive&0xff00)|'');
			_vputc(cw->win->x2,cw->win->y1+2,(cw->col.factive&0xff00)|'');
			_vlwrite(cw->win->x1+1,cw->win->y1+2,(cw->col.factive&0xff00)|'',
				cw->win->x2-cw->win->x1-1);
			prtcwnd(-2,cw->title,cw->col.tactive);
		}
	}
}

void cwtitle(CWWINDOW *cw,char far *title)
{
	if (cw && title)
		cw->title=title;
	cwactivate(cw,0);
}

void cwinactivate(CWWINDOW *cw,int fill)
{
	if (cw && cw->win) {
		_drawbox(cw->win->x1,cw->win->y1,
			cw->win->x2,cw->win->y2,DOUBLEFRAME,cw->col.finactive,fill);
		if (cw->title) {
			_vputc(cw->win->x1,cw->win->y1+2,(cw->col.finactive&0xff00)|'');
			_vputc(cw->win->x2,cw->win->y1+2,(cw->col.finactive&0xff00)|'');
			_vlwrite(cw->win->x1+1,cw->win->y1+2,(cw->col.finactive&0xff00)|'',
				cw->win->x2-cw->win->x1-1);
			prtcwnd(-2,cw->title,cw->col.tinactive);
		}
	}
}

CWWINDOW *cwwindow(int x,int y,int cols,int rows,
		char *title,CWCOLORS *col)
{
//int i;
CWWINDOW *cw;
	_videoparm();
	if (x==-1)
		x=_videocblk.cols/2-cols/2-1;
	if (y==-1)
		y=_videocblk.rows/2-rows/2-1;
	cols=cols+x+1;
	rows=rows+y+1;
	if (title) {
		y--;
		rows++;
	}
	if (cwcurntwnd)
		cwinactivate(cwcurntwnd,0);
	cw=malloc(sizeof(CWWINDOW));
	if (cw) {
		if (makewnd(x,y,cols,rows,DOUBLEFRAME,col->factive,0)) {
			cw->back=cwcurntwnd;
			cwcurntwnd=cw;
			cw->win=_curntwnd;
			cw->title=title;
			memcpy(&cw->col,col,sizeof(CWCOLORS));
			if (title)
				_curntwnd->vy1+=2;
			cwactivate(cw,1);
			return cw;
		}
		free(cw);
	}
	return NULL;
}

void cwshowframe(CWMENU *m)
{
int i;
char *s;
	s=m->s;
	i=_curntwnd->vy1;
	while (i<=_curntwnd->vy2) {
		if (!*s)
			break;
		_vputscp(_curntwnd->vx1,i,(m->x<strlen(s))?s+m->x:"",
			_curntwnd->color,_curntwnd->vx2-_curntwnd->vx1+1);
		while (*s++);
		i++;
	}
	while (i<=_curntwnd->vy2) {
		_vputscp(_curntwnd->vx1,i,"",_curntwnd->color,
					_curntwnd->vx2-_curntwnd->vx1+1);
		i++;
	}
}

void bigcursor(void)
{
	_setcursize(_videocblk.scan-1);
}

void smallcursor(void)
{
	_setcursize(0x0607);
}

/*
** returns 1 if s matches the beginning of t.
*/
int cwstrbeg(char *s,char *t)
{
int i;
	for (i=0;s[i] && t[i];i++) {
		if ((_mapuphook)(s[i])!=(_mapuphook)(t[i]))
			return 0;
	}
	return 1;
}

int flook(CWMENU *m,char *lookup)
{
char *s;
long i=0;
	s=m->text;
	while (*s) {
		if (cwstrbeg(lookup,s)) {
			if (i>=m->line && i-m->line<m->wrows) {
				m->cursor=i-m->line;
				return 1;
			}
			m->cursor=0;
			m->line=i;
			m->s=s;
			return 1;
		}
		while (*s++);
		i++;
	}
	return 0;
}

word cwmenu(CWMENU *m,int reinit,word (*input)(void))
{
word key;
word wcols;
int xcount;
//WINDOW far *win;
int csize;
char lookup[40];
int luidx=0,i;
	if (m && m->cw) {
		csize=_getcursize();
		cwactivate(m->cw,0);
		m->wrows=_curntwnd->vy2-_curntwnd->vy1+1;
		if (!m->wrows)
			m->wrows=1;
		for (xcount=0;xcount<m->wrows;xcount++)
			prtwnd(0,xcount," ",m->cw->col.ruler);
		xcount=0;
		_curntwnd->vx1+=2;
		wcols=_curntwnd->vx2-_curntwnd->vx1+1;
		if (reinit) {
			m->line=m->nlines=0;
			m->cursor=0;
			m->x=0;
			m->s=m->text;
			while (*m->s) {
				m->nlines++;
				while (*m->s++);
			}
			m->s=m->text;
		}
		cwshowframe(m);
		while (1) {
			if (!xcount) {
				if ((long)m->wrows<m->nlines) {
					_vputc(_curntwnd->vx1-2,_curntwnd->vy1,
						(m->cw->col.ruler<<8)|((m->line)?0x1e:' '));
					_vputc(_curntwnd->vx1-2,_curntwnd->vy2,
						(m->cw->col.ruler<<8)|((m->line+(long)m->wrows<m->nlines)?0x1f:' '));
				}
				_recolor(_curntwnd->vx1,_curntwnd->vy1+m->cursor,
							wcols,m->cw->col.cactive);
				if (luidx)
					smallcursor();
				else
					cursoroff();
				locate((luidx<wcols)?luidx-1:wcols-1,m->cursor);
				key=(*input)();
				_recolor(_curntwnd->vx1,_curntwnd->vy1+m->cursor,
							wcols,_curntwnd->color);
			}
			else {
				xcount--;
				if (!xcount)
					cwshowframe(m);
			}
			switch(key) {
				default:
					if (m->exitkeys) {
						for (i=0;m->exitkeys[i];i++) {
							if (key==m->exitkeys[i])
								goto leavemenu;
						}
					}
					if (key&0xff) {
						if (luidx<sizeof lookup-1 && luidx<wcols) {
							key=(_mapuphook)(key&0xff);
							lookup[luidx++]=key;
							lookup[luidx]='\0';
							if (!flook(m,lookup)) {
								luidx--;
								lookup[luidx]='\0';
							}
							else
								cwshowframe(m);
						}
					}
					break;
				case ME_BS_KEY:
					if (luidx) {
						luidx--;
						lookup[luidx]='\0';
						if (flook(m,lookup))
							cwshowframe(m);
					}
					break;
/*
				case ME_MOVE_RT_KEY:
					m->x+=3;
					cwshowframe(m);
					break;
				case ME_MOVE_LT_KEY:
					if (m->x) {
						m->x-=3;
						if (m->x<0)
							m->x=0;
						cwshowframe(m);
					}
					break;
*/
				case ME_MOVE_UP_KEY:
					if (m->cursor>0)
						m->cursor--;
					else {
						if (m->line>0) {
							m->s--;
							while (m->s!=m->text && *--m->s);
							if (m->s!=m->text)
								m->s++;
							m->line--;
							if (!xcount)
								cwshowframe(m);
						}
					}
					luidx=0;
					*lookup='\0';
					break;
				case ME_MOVE_DN_KEY:
					if (m->nlines && m->line+m->cursor<m->nlines-1) {
						if (m->cursor<m->wrows-1)
							m->cursor++;
						else {
							m->line++;
							while (*m->s++);
							if (!xcount)
								cwshowframe(m);
						}
					}
					luidx=0;
					*lookup='\0';
					break;
				case ME_PAGE_UP_KEY:
					key=ME_MOVE_UP_KEY;
					xcount=m->wrows-1;
					break;
				case ME_PAGE_DN_KEY:
					key=ME_MOVE_DN_KEY;
					xcount=m->wrows-1;
					break;
				case ME_CR_KEY:
				case ME_ESC_KEY:
leavemenu:
					luidx=0;
					*lookup='\0';
					_recolor(_curntwnd->vx1,_curntwnd->vy1+m->cursor,
							wcols,m->cw->col.cinactive);
					_curntwnd->vx1-=2;
					_setcursize(csize);
					return key;
			}
		}
	}
	return 0xffff;
}

void cwclose(CWWINDOW *cw)
{
	if (cw) {
		if (cw->win) {
			closewnd();
		}
		cwcurntwnd=cw->back;
		cwactivate(cw->back,0);
		free(cw);
	}
}

static CWMENU yesnomenu = {
	0,
	0,
	0,
	0,
	0,
	NULL,
	NULL,
	NULL,
	"Yes\0"
	"No\0"
	"\0"
};

int yesnobox(char *prompt,CWCOLORS *pal)
{
	yesnomenu.cw=cwwindow(-1,-1,strlen(prompt)+4,2,prompt,pal);
	if (yesnomenu.cw) {
		if (cwmenu(&yesnomenu,1,cwinputkey)!=ME_ESC_KEY) {
			cwclose(yesnomenu.cw);
			return (yesnomenu.cursor)?0:1;
		}
		cwclose(yesnomenu.cw);
	}
	return 0;
}

int cwinput(char *buf,int maxlen,CWCOLORS *pal,word pad,char *title)
{
CWWINDOW *win;
	win=cwwindow(-1,-1,(maxlen>strlen(title))?maxlen+4:strlen(title)+4,
		1,title,pal);
	if (win) {
		getwinp(2,0,pad,
			buf,maxlen-1,cwinputkey);
		cwclose(win);
	}
	return 1;
}

CWWINDOW * statusbox(char *s,CWCOLORS *pal)
{
CWWINDOW *cw;
int lines=1,cols=0,i=0;
char *t;
	t=s;
	while (*t) {
		if (*t=='\n')
			lines++;
		if (*t=='\r') {
			if (cols<i)
				cols=i;
			i=-1;
		}
		t++;
		i++;
	}
	if (cols<i)
		cols=i;
	cw=cwwindow(-1,-1,cols+4,lines,"Message",pal);
	if (cw) {
		_curntwnd->vx1+=2;
		putswnd(s);
	}
	return cw;
}

int messagebox(char *s,CWCOLORS *pal)
{
CWWINDOW *cw;
int w=0;
	cw=statusbox(s,pal);
	if (cw) {
		w=cwinputkey();
		cwclose(cw);
	}
	return w;
}

/*
CWMENU cm = {
	0,
	0,
	0,
	0,
	0,
	NULL,
	NULL,
	"Zero\0"
	"First line\0"
	"Second Line\0"
	"Pegasus Mail\0"
	"Norton Commander\0"
	"Client Database\0"
	"Six 123\0"
	"Six 132\0"
	"Seven\0"
	"Eight\0"
	"Nine\0"
	"Another one\0"
	"\0"
};

void main(void)
{
CWWINDOW *cw[5];
char s[80];
	_videoparm();
	makewnd(0,0,_videocblk.cols-1,_videocblk.rows-1,"",0x1313,1000);
	framesoff();
	cursoroff();
	makewnd(0,0,_videocblk.cols-1,3,SINGLEFRAME,0x3131,1000);
	cm.cw=cw[0]=cwwindow(-1,-1,30,10,"C-Worthy window",&palette);
	if (cwmenu(&cm,1,waitkey)!=ME_ESC_KEY) {
		while (1) {
			switch (cm.line+cm.cursor) {
				case 3:
					makewnd(0,0,_videocblk.cols-1,_videocblk.rows-1,"",0,0);
					system("pmail");
					closewnd();
					break;
				case 4:
					makewnd(0,0,_videocblk.cols-1,_videocblk.rows-1,"",0,0);
					system("nc");
					closewnd();
					break;
				case 5:
					system("cdabe");
					break;
				default:
					cw[1]=cwwindow(4,-1,25,15,NULL,&palette);
					sprintf(s,"You are one the line %ld",cm.line+cm.cursor);
					putswnd(s);
					waitkey();
					cwclose(cw[1]);
					break;
			}
			if (cwmenu(&cm,0,waitkey)==ME_ESC_KEY)
				break;
		}
	}
	cwclose(cw[0]);
	while (closewnd());
}
*/
