#ifndef __CWLOOK_H__

#include "slick!.h"
#include "menueng.h"

typedef struct {
	word factive;				// frame & interior
	word finactive;
	byte tactive;				// title
	byte tinactive;
	byte cactive;				// cursor bar
	byte cinactive;
	byte ruler;					// ruler
} CWCOLORS;

typedef struct _cwwindow CWWINDOW;
struct _cwwindow {
	CWWINDOW *back;
	WINDOW far *win;
	CWCOLORS col;
	char far *title;
};

typedef struct {
	word cursor;
	long nlines;
	long line;
	int x;
	int wrows;
	word *exitkeys;
	char *s;
	CWWINDOW *cw;
	char *text;
} CWMENU;

extern CWWINDOW *cwcurntwnd;

#ifdef __cplusplus
extern "C" {
#endif

extern word cdecl cwinputkey(void);

extern void cdecl cwtitle(CWWINDOW *cw,char far *title);
extern void cdecl cwactivate(CWWINDOW *cw,int fill);
extern void cdecl cwinactivate(CWWINDOW *cw,int fill);
extern CWWINDOW * cdecl cwwindow(int x,int y,int cols,int rows,
		char *title,CWCOLORS *col);
extern void cdecl cwshowframe(CWMENU *m);
extern void cdecl bigcursor(void);
extern void cdecl smallcursor(void);
extern int cdecl cwstrbeg(char *s,char *t);
extern int cdecl flook(CWMENU *m,char *lookup);
extern word cdecl cwmenu(CWMENU *m,int reinit,word (*input)(void));
extern void cdecl cwclose(CWWINDOW *cw);
extern int cdecl yesnobox(char *prompt,CWCOLORS *pal);
extern int cdecl messagebox(char *s,CWCOLORS *pal);
extern CWWINDOW * cdecl statusbox(char *s,CWCOLORS *pal);
extern int cdecl cwinput(char *buf,int maxlen,CWCOLORS *pal,word pad,char *title);

#ifdef __cplusplus
}
#endif

#define __CWLOOK_H__
#endif

